"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Graph = void 0;

var _react = require("@graspologic/react");

var _renderControlsReact = require("@graspologic/render-controls-react");

var React = _interopRequireWildcard(require("react"));

var _useResizeObserver2 = _interopRequireDefault(require("use-resize-observer"));

var _interfaces = require("../interfaces");

var _GlobalStyles = require("./GlobalStyles");

var _useColorizer = require("./hooks/useColorizer");

var _useGraphData = require("./hooks/useGraphData");

var _useHoverHandler = require("./hooks/useHoverHandler");

var _usePositionChanges = require("./hooks/usePositionChanges");

var _useVertexClickHandler = require("./hooks/useVertexClickHandler");

var _vac = require("./hooks/vac");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var styles = {
  brickWall: {
    height: '100%',
    width: '100%'
  }
};
var Graph = (0, React.memo)(function GraphComponentInner(_ref) {
  var manager = _ref.manager,
      configuration = _ref.configuration;
  var showControls = configuration.showControls != null ? configuration.showControls : true;
  var renderSettings = (0, React.useMemo)(function () {
    return configuration.rendering || {};
  }, [configuration]);
  var controlsSettings = (0, React.useMemo)(function () {
    return configuration.controls || {};
  }, [configuration]);

  var _useState = (0, React.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      api = _useState2[0],
      setApi = _useState2[1];

  var is3D = Boolean(renderSettings.is3D);
  var colorizer = (0, _useColorizer.useColorizer)(manager, configuration);
  var graphData = (0, _useGraphData.useGraphData)(manager, is3D);
  var handleVertexClick = (0, _useVertexClickHandler.useVertexClickHandler)(manager);
  var highlighted = (0, _vac.useHighlightedVertices)(manager);
  var selected = (0, _vac.useSelectedVertices)(manager);
  var onHover = (0, _useHoverHandler.useHoverHandler)(manager);

  var _useResizeObserver = (0, _useResizeObserver2.default)(),
      ref = _useResizeObserver.ref;

  (0, _usePositionChanges.usePositionChanges)(api, configuration, manager);
  var instanceId = configuration.instanceId || _interfaces.DEFAULT_INSTANCE_ID;
  var renderConfig = api === null || api === void 0 ? void 0 : api.config;
  (0, React.useEffect)(function () {
    if (renderConfig) {
      // Load any existing config at startup
      var existingState = manager.getState(_interfaces.COMPONENT_ID, instanceId);

      if (existingState) {
        renderConfig.load(existingState);
      } // Set up a subscription


      var subscription = renderConfig.onChange.subscribe(function () {
        manager.setState(_interfaces.COMPONENT_ID, instanceId, renderConfig.copy());
      });
      return function () {
        return subscription.unsubscribe();
      };
    }
  }, [renderConfig, instanceId, manager]);
  return React.createElement(React.Fragment, null, React.createElement(_GlobalStyles.GlobalStyles, null), React.createElement("div", {
    style: styles.brickWall,
    ref: ref
  }, React.createElement(_react.GraphView, {
    colorizer: colorizer,
    data: graphData,
    backgroundColor: [0, 0, 0, 0],
    is3D: is3D,
    ref: (0, React.useCallback)(function (ref) {
      if (ref !== api) {
        setApi(ref);
      }
    }, [api]),
    style: styles.brickWall
  }, React.createElement(_react.Axes, {
    inCorner: renderSettings.cornerAxes,
    shown: renderSettings.drawAxes
  }), React.createElement(_react.Camera, {
    interactive: true
  }), React.createElement(_react.HandleNodeClicks, {
    onClick: handleVertexClick
  }), React.createElement(_react.HighlightHoveredNode, {
    onHover: onHover
  }), React.createElement(_react.LabelHoveredNode, null), React.createElement(_react.NodeSetHighlight, {
    vertexIds: highlighted
  }), React.createElement(_react.NodeSetLabel, {
    vertexIds: highlighted
  }), React.createElement(_react.NodeSetHighlight, {
    vertexIds: selected
  }), React.createElement(_react.NodeSetLabel, {
    vertexIds: selected
  }), React.createElement(_react.Nodes, {
    shown: renderSettings.drawNodes,
    minRadius: renderSettings.nodeMinRadius,
    maxRadius: renderSettings.nodeMaxRadius,
    outline: renderSettings.nodeOutline,
    hideOnMove: renderSettings.hideNodesOnMove
  }), React.createElement(_react.Edges, {
    shown: renderSettings.drawEdges,
    alpha: renderSettings.edgeAlpha,
    minWidth: renderSettings.edgeMinWidth,
    maxWidth: renderSettings.edgeMaxWidth,
    hideOnMove: renderSettings.hideNodesOnMove,
    depthWrite: renderSettings.edgeDepthWrite,
    antialias: renderSettings.edgeAntialias,
    constantWidth: renderSettings.constantEdgeWidth
  }), showControls ? React.createElement(_renderControlsReact.SettingsPane, null, React.createElement(_renderControlsReact.DisplaySettings, {
    interpolationTimeRange: controlsSettings.displayInterpolationTimeRange
  }), React.createElement(_renderControlsReact.NodeSettings, {
    minRadiusRange: controlsSettings.nodeMinRadiusRange,
    maxRadiusRange: controlsSettings.nodeMaxRadiusRange
  }), React.createElement(_renderControlsReact.EdgeSettings, {
    alphaRange: controlsSettings.edgeAlphaRange,
    minWidthRange: controlsSettings.edgeMinWidthRange,
    maxWidthRange: controlsSettings.edgeMaxWidthRange
  })) : null)));
});
exports.Graph = Graph;