"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useHoverHandler = useHoverHandler;

var _react = require("react");

var _visualAnalyticsComponents = require("visual-analytics-components");

/*!
 * Copyright (c) Microsoft. All rights reserved.
 * Licensed under the MIT license. See LICENSE file in the project.
 */
function useHoverHandler(manager) {
  return (0, _react.useCallback)(function (id) {
    if (manager) {
      var evt = id ? setSelection(id) : clearSelection();
      manager.publish(evt);
    }
  }, [manager]);
}

var setSelection = function setSelection(id) {
  return _visualAnalyticsComponents.MessageCreators.Highlight.replaceWithIds(LOCATION, [id]);
};

var clearSelection = function clearSelection() {
  return _visualAnalyticsComponents.MessageCreators.Highlight.clear(LOCATION);
};

var LOCATION = {
  table: 'vertices'
};