"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSlice = useSlice;

var _react = require("react");

/*!
 * Copyright (c) Microsoft. All rights reserved.
 * Licensed under the MIT license. See LICENSE file in the project.
 */
function useSlice(manager, slice) {
  return (0, _react.useMemo)(function () {
    if (manager) {
      var table = manager.data.table('vertices');

      if (table) {
        return table.slice(slice);
      }
    }

    return undefined;
  }, [manager, slice]);
}