"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useVertexClickHandler = useVertexClickHandler;

var _react = require("react");

var _visualAnalyticsComponents = require("visual-analytics-components");

function useVertexClickHandler(manager) {
  return (0, _react.useCallback)(function (id) {
    var evt = id ? newVertexSelectionEvent(id) : clearVertexSelectionEvent();
    manager.publish(evt);
  }, [manager]);
}

var clearVertexSelectionEvent = function clearVertexSelectionEvent() {
  return _visualAnalyticsComponents.MessageCreators.Selection.clear(LOCATION);
};

var newVertexSelectionEvent = function newVertexSelectionEvent(id) {
  return _visualAnalyticsComponents.MessageCreators.Selection.replaceWithIds(LOCATION, [id], SELECTION_LOG);
};

var LOCATION = {
  table: 'vertices',
  key: 'graph_view'
};
var SELECTION_LOG = 'Examining Vertex';