import { useMemo } from 'react';
export function useColorizer(manager, config) {
  return useMemo(function () {
    if (config.colorizer) {
      return config.colorizer;
    } else if (manager.theme) {
      var f = manager.theme.scales().nominal(50);
      return function (key) {
        return f(key).rgbav();
      };
    } else {
      return function () {
        return [1, 0, 0, 1];
      };
    }
  }, [manager, config]);
}