/*!
 * Copyright (c) Microsoft. All rights reserved.
 * Licensed under the MIT license. See LICENSE file in the project.
 */
import { useCallback } from 'react';
import { MessageCreators } from 'visual-analytics-components';
export function useHoverHandler(manager) {
  return useCallback(function (id) {
    if (manager) {
      var evt = id ? setSelection(id) : clearSelection();
      manager.publish(evt);
    }
  }, [manager]);
}

var setSelection = function setSelection(id) {
  return MessageCreators.Highlight.replaceWithIds(LOCATION, [id]);
};

var clearSelection = function clearSelection() {
  return MessageCreators.Highlight.clear(LOCATION);
};

var LOCATION = {
  table: 'vertices'
};