/*!
 * Copyright (c) Microsoft. All rights reserved.
 * Licensed under the MIT license. See LICENSE file in the project.
 */
import { useMemo } from 'react';
export function useSlice(manager, slice) {
  return useMemo(function () {
    if (manager) {
      var table = manager.data.table('vertices');

      if (table) {
        return table.slice(slice);
      }
    }

    return undefined;
  }, [manager, slice]);
}