import { useCallback } from 'react';
import { MessageCreators } from 'visual-analytics-components';
export function useVertexClickHandler(manager) {
  return useCallback(function (id) {
    var evt = id ? newVertexSelectionEvent(id) : clearVertexSelectionEvent();
    manager.publish(evt);
  }, [manager]);
}

var clearVertexSelectionEvent = function clearVertexSelectionEvent() {
  return MessageCreators.Selection.clear(LOCATION);
};

var newVertexSelectionEvent = function newVertexSelectionEvent(id) {
  return MessageCreators.Selection.replaceWithIds(LOCATION, [id], SELECTION_LOG);
};

var LOCATION = {
  table: 'vertices',
  key: 'graph_view'
};
var SELECTION_LOG = 'Examining Vertex';