import { useMemo } from 'react';
export function useColorizer(manager, config) {
    return useMemo(() => {
        if (config.colorizer) {
            return config.colorizer;
        }
        else if (manager.theme) {
            const f = manager.theme.scales().nominal(50);
            return (key) => f(key).rgbav();
        }
        else {
            return () => [1, 0, 0, 1];
        }
    }, [manager, config]);
}
