/*!
 * Copyright (c) Microsoft. All rights reserved.
 * Licensed under the MIT license. See LICENSE file in the project.
 */
import { useCallback } from 'react';
import { MessageCreators, } from 'visual-analytics-components';
export function useHoverHandler(manager) {
    return useCallback((id) => {
        if (manager) {
            const evt = id ? setSelection(id) : clearSelection();
            manager.publish(evt);
        }
    }, [manager]);
}
const setSelection = (id) => MessageCreators.Highlight.replaceWithIds(LOCATION, [id]);
const clearSelection = () => MessageCreators.Highlight.clear(LOCATION);
const LOCATION = {
    table: 'vertices',
};
