import { useCallback } from 'react';
import { MessageCreators, } from 'visual-analytics-components';
export function useVertexClickHandler(manager) {
    return useCallback((id) => {
        const evt = id ? newVertexSelectionEvent(id) : clearVertexSelectionEvent();
        manager.publish(evt);
    }, [manager]);
}
const clearVertexSelectionEvent = () => MessageCreators.Selection.clear(LOCATION);
const newVertexSelectionEvent = (id) => MessageCreators.Selection.replaceWithIds(LOCATION, [id], SELECTION_LOG);
const LOCATION = {
    table: 'vertices',
    key: 'graph_view',
};
const SELECTION_LOG = 'Examining Vertex';
